<?php
/***************************************************************************
 *                                                                          *
 *    Copyright (c) 2009 Simbirsk Technologies Ltd. All rights reserved.    *
 *                                                                          *
 * This  is  commercial  software,  only  users  who have purchased a valid *
 * license  and  accept  to the terms of the  License Agreement can install *
 * and use this program.                                                    *
 *                                                                          *
 ****************************************************************************
 * PLEASE READ THE FULL TEXT  OF THE SOFTWARE  LICENSE   AGREEMENT  IN  THE *
 * "copyright.txt" FILE PROVIDED WITH THIS DISTRIBUTION PACKAGE.            *
 ****************************************************************************/

// $Id: checkout.pre.php by andplus 2022

use Tygh\Tygh;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

if ($mode == 'checkout') {

    //session(カートデータ)
    $ap_session = &Tygh::$app['session'];

    //登録済みの事前トークンを呼び出しておく act_as_userの時は事前トークンは呼び出さない形に
    if(!empty($ap_session['cart']['user_data']['user_id']) && !empty($auth['user_id']) && empty($auth['act_as_user'])) {
        $pre_token = db_get_field('SELECT user_token FROM ?:users WHERE user_id = ?i', $ap_session['cart']['user_data']['user_id']);
        if(!empty($pre_token) && $ap_session['cart']['user_data']['user_id'] === $auth['user_id']) {
            //事前トークンが存在し、かつカートのuser_idとauthのuser_idが一致するようならassign
            Tygh::$app['view']->assign('atn_token', $pre_token);
        }
    }
    
    //POSTした時
    if ($_SERVER['REQUEST_METHOD'] == 'POST' && ( !empty($_REQUEST['atn_token']) || !empty($_REQUEST['atn_tr_no']) || !empty($_REQUEST['atonecancel']) || !empty($_REQUEST['atn_tr_id']) )) {

		//選択されている決済がatone決済の場合のみ
		if(!empty($ap_session['cart']['payment_method_data']) && $ap_session['cart']['payment_method_data']['processor_id'] == '9088') {
			
			//既にtransaction_noを保持している場合に、異なるnoでのリクエストがあったらsessionの値を空にする
			if(!empty($ap_session['atn_tr_no']) && !empty($_REQUEST['atn_tr_no']) && $ap_session['atn_tr_no'] != $_REQUEST['atn_tr_no']) {
        		if(!empty($ap_session['atn_tr_no'])) {
                	unset($ap_session['atn_tr_no']);
            	}
            	if(!empty($ap_session['atn_tr_id'])) {
            		fn_atn_canceled_auto_ex($ap_session['atn_tr_id']);
                	unset($ap_session['atn_tr_id']);
            	}
            	if(!empty($ap_session['atn_token'])) {
                	unset($ap_session['atn_token']);
            	}
            	if(!empty($ap_session['atn_guest_token'])) {
                	unset($ap_session['atn_guest_token']);
            	}
    			exit;
        	}
        	
        	//既にtr_idを保持している場合に、異なるidでのリクエストがあったらsessionの値を空にする
			if(!empty($ap_session['atn_tr_id']) && !empty($_REQUEST['atn_tr_id']) && $ap_session['atn_tr_id'] != $_REQUEST['atn_tr_id']) {
        		if(!empty($ap_session['atn_tr_no'])) {
                	unset($ap_session['atn_tr_no']);
            	}
            	if(!empty($ap_session['atn_tr_id'])) {
            		fn_atn_canceled_auto_ex($ap_session['atn_tr_id']);
                	unset($ap_session['atn_tr_id']);
            	}
            	if(!empty($_REQUEST['atn_tr_id'])) {
            		fn_atn_canceled_auto_ex($_REQUEST['atn_tr_id']);
            	}
            	if(!empty($ap_session['atn_token'])) {
                	unset($ap_session['atn_token']);
            	}
            	if(!empty($ap_session['atn_guest_token'])) {
                	unset($ap_session['atn_guest_token']);
            	}
    			exit;
        	}
        	
        	//既にtokenを保持している場合に、異なるtokenでのリクエストがあったらsessionの値を空にする
			if(!empty($ap_session['atn_token']) && !empty($_REQUEST['atn_token']) && $ap_session['atn_token'] != $_REQUEST['atn_token']) {
        		if(!empty($ap_session['atn_tr_no'])) {
                	unset($ap_session['atn_tr_no']);
            	}
            	if(!empty($ap_session['atn_tr_id'])) {
            		fn_atn_canceled_auto_ex($ap_session['atn_tr_id']);
                	unset($ap_session['atn_tr_id']);
            	}
            	if(!empty($ap_session['atn_token'])) {
                	unset($ap_session['atn_token']);
            	}
            	if(!empty($ap_session['atn_guest_token'])) {
                	unset($ap_session['atn_guest_token']);
            	}
    			exit;
        	}
        	
        	//既にguest_tokenを保持している場合に、異なるtokenでのリクエストがあったらsessionの値を空にする
			if(!empty($ap_session['atn_guest_token']) && !empty($_REQUEST['atn_token']) && $ap_session['atn_guest_token'] != $_REQUEST['atn_token']) {
        		if(!empty($ap_session['atn_tr_no'])) {
                	unset($ap_session['atn_tr_no']);
            	}
            	if(!empty($ap_session['atn_tr_id'])) {
            		fn_atn_canceled_auto_ex($ap_session['atn_tr_id']);
                	unset($ap_session['atn_tr_id']);
            	}
            	if(!empty($ap_session['atn_token'])) {
                	unset($ap_session['atn_token']);
            	}
            	if(!empty($ap_session['atn_guest_token'])) {
                	unset($ap_session['atn_guest_token']);
            	}
    			exit;
        	}

			//transaction_idの格納
    		if(!empty($_REQUEST['atn_tr_id'])) {
        		//sessionに値を格納
        		$ap_session['atn_tr_id'] = $_REQUEST['atn_tr_id'];
    		}

        	//事前トークンの格納
        	if(!empty($_REQUEST['atn_token']) && !empty($ap_session['cart']['user_data']['user_id']) && !empty($auth['user_id']) && empty($auth['act_as_user'])) {
            	if((int)$ap_session['cart']['user_data']['user_id'] === (int)$auth['user_id']) {
                	$set_pre_token = $_REQUEST['atn_token'];
                	//取得した時点でもDBに保存
                	if(!empty($_REQUEST['caid']) && (int)$_REQUEST['caid'] === (int)$auth['user_id']) {
                    	db_query('UPDATE ?:users SET user_token = ?s WHERE user_id = ?i',$set_pre_token, (int)$auth['user_id']);
                    	$ap_session['atn_token'] = $set_pre_token;
                	}
            	}
        	}
        	
        	//ゲストユーザーのトークン格納
        	if(!empty($_REQUEST['atn_token']) && empty($auth['user_id'])) {
        		$set_guest_token = $_REQUEST['atn_token'];
                $ap_session['atn_guest_token'] = $set_guest_token;
        	}

        	//transaction_noの格納
        	if(!empty($_REQUEST['atn_tr_no'])) {
            	//sessionに値を格納
            	$ap_session['atn_tr_no'] = $_REQUEST['atn_tr_no'];
        	}
        
        }

        //モーダルを閉じた場合・atone側での決済に失敗した場合にsessionに格納した値を一旦空にする
        if(!empty($_REQUEST['atonecancel'])) {
            if(!empty($ap_session['atn_tr_no'])) {
                unset($ap_session['atn_tr_no']);
            }
            if(!empty($ap_session['atn_tr_id'])) {
            	fn_atn_canceled_auto_ex($ap_session['atn_tr_id']);
                unset($ap_session['atn_tr_id']);
            }
            if(!empty($ap_session['atn_token'])) {
                unset($ap_session['atn_token']);
            }
            if(!empty($ap_session['atn_guest_token'])) {
                unset($ap_session['atn_guest_token']);
            }
        }
        exit;
    }
}
